AGSScriptModule    Asraroth (+Kitai) Prints bubble speech Phylactere 233_modified Q  //===================================================================
// *** AGS MODULE SCRIPT ***
//
// Module: Phylactere
//
// Author: Asraroth (http://adventuregamestudio.fr-bb.com)
//
// Require: AGS 3
//
// Description
//      To make Bubulles
//
// Revision History
//      2009-02-10 - (V1.00) 
//      2009-02-11 - (V1.10)
//      2009-02-12 - (V1.11) Correction BUG avec Scaling et Scrolling
//      2009-02-16 - (V1.20) Alignement "centrE du texte
//                                   Ajout des modes TALKING et THINKING
//      2009-02-17 - (V1.21) Optimization (1 seul overlay)
//      2009-02-17 - (V2.00) Transparence
//      2009-02-19 - (V2.10) parametrage
//      2009-02-20 - (V2.20) encore + de parametrage
//      2009-06-03 - (V2.30) correction du bug reperEpar Shai-la ^^
//      2009-06-03 - (V2.31) plus de speech animation en mode "think"
//      2009-06-04 - (V2.32) ajout contrle du debordement de l'cran
//      2009-06-15 - (V2.33) correction pour les "Translations"
//      2012-05-16 - (V2.33_MODIFIED) Ajout PhylactereBackground
//                                   Correction eSkipOnlyKeyOrClick
//
// This  module  is  free  software;  you  can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as  published  by the Free Software Foundation; either version 2.1 
// of the License, or any later version.
//
// This module is distributed in the hope that it will be useful, but
// WITHOUT  ANY  WARRANTY;  without  even  the  implied  warranty  of 
// MERCHANTABILITY or  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
// 
// You  should  have received a copy of the GNU Lesser General Public
// License along with this library; if not,write to the Free Software
// Foundation, Inc, 59 Temple Place, Suite 330, Boston, MA 02111-1307  
// USA.
// 
// Copyright (C) 2009 Asraroth
//-------------------------------------------------------------------

Overlay *bulle[];
DynamicSprite *ds[];
PhylactereQueueMode mod[];
int posx[], posy[];
int charx[], chary[];
int viewx[], viewy[];
int tempo[];
bool isbackground[];


Phylactere_Param phylactere;
export phylactere;

int Phylactere_col_r;
int Phylactere_col_g;
int Phylactere_col_b;

function game_start() {
  /* ------------- PARAMETRAGE --------------- */
  phylactere.background_color = 15;
  phylactere.is_transparent = false;
  phylactere.outline_color = 0;
  phylactere.speed = 35;
  phylactere.transparency = 0;
  phylactere.transparency_red = 255;
  phylactere.transparency_green = 255;
  phylactere.transparency_blue = 255;
  phylactere.width = 300;
  phylactere.distance_from_head = 6;
  phylactere.view_speed = 5;
  phylactere.ajust_htext = 5;
  phylactere.skip_mode = eSkipKeyOrClick;
  /* ------------------------------------------ */
  
  
  bulle = new Overlay[Game.CharacterCount];
  ds = new DynamicSprite[Game.CharacterCount];
  mod = new PhylactereQueueMode[Game.CharacterCount];
  charx = new int[Game.CharacterCount];
  chary = new int[Game.CharacterCount];
  posx = new int[Game.CharacterCount];
  posy = new int[Game.CharacterCount];
  viewx = new int[Game.CharacterCount];
  viewy = new int[Game.CharacterCount];
  tempo = new int[Game.CharacterCount];
  isbackground = new bool[Game.CharacterCount];
  
}

function getRVG(int color) {
  int c = color;
  if (c == -1) c = 63519;
  int cc = c / 2048;
  int cr , cg, cb;
  cr = cc * 8;
  c = c - (cc * 2048);
  cc = c / 64;
  cg = (cc * 8);
  c = c - (cc * 64);
  if (cg > 0) {
    cg += 4;
    c -= 32;
  }
  cb = c * 8;
  if (cb < 0) {
    if (cg > 4) cg -= 4;
    cb = 256 + cb;
  }
  Phylactere_col_r = ((cr * phylactere.transparency) + (phylactere.transparency_red * (100 - phylactere.transparency))) / 100;
  if (Phylactere_col_r > 255) Phylactere_col_r = 255;
  if (Phylactere_col_r < 0) Phylactere_col_r = 0;
  Phylactere_col_g = ((cg * phylactere.transparency) + (phylactere.transparency_green * (100 - phylactere.transparency))) / 100;
  if (Phylactere_col_g > 255) Phylactere_col_g = 255;
  if (Phylactere_col_g < 0) Phylactere_col_g = 0;
  Phylactere_col_b = ((cb * phylactere.transparency) + (phylactere.transparency_blue * (100 - phylactere.transparency))) / 100;
  if (Phylactere_col_b > 255) Phylactere_col_b = 255;
  if (Phylactere_col_b < 0) Phylactere_col_b = 0;
}

function Efface_Bulle(int i) {
  
  // Efface la bulle
  if (ds[i] != null) ds[i].Delete();
  ds[i] = null;
  if (bulle[i] != null) bulle[i].Remove();
  bulle[i] = null;
  
  // Arrete l'animation Speech
  if (character[i].SpeechView > 0) {
    if (mod[i] != ePhylactereThinking) {
      character[i].UnlockView();
    }
  }

}

function prepare(this Character* , String str,  PhylactereQueueMode mode) {
 
  if (IsTranslationAvailable()) str = GetTranslation(str);
 
  String GQueue[20]; // Dessin de la Queue (X = Contour, O = Fond)
  int queue_height = 0;
 
  if (mode == ePhylactereTalking) {
    GQueue[01] = "OOOOOOOO";
    GQueue[02] = "XOOOOOXX";
    GQueue[03] = "XOOOOX  ";
    GQueue[04] = "XOOOOX  ";
    GQueue[05] = " XOOOX  ";
    GQueue[06] = " XOOOX  ";
    GQueue[07] = "  XOOOX ";
    GQueue[08] = "   XOOOX";
    GQueue[09] = "    XXX ";
    queue_height = 9;
  }

  if (mode == ePhylactereThinking) {
    GQueue[01] = "        ";
    GQueue[02] = "        ";
    GQueue[03] = "  XX    ";
    GQueue[04] = " XOOX   ";
    GQueue[05] = "XOOOOX  ";
    GQueue[06] = "XOOOOX  ";
    GQueue[07] = " XOOX   ";
    GQueue[08] = "  XX    ";
    GQueue[09] = "        ";
    GQueue[10] = "    XX  ";
    GQueue[11] = "   XOOX ";
    GQueue[12] = "   XOOX ";
    GQueue[13] = "    XX  ";
    queue_height = 13;
  }
  
  // Controle des parametres
  if (phylactere.transparency < 0) phylactere.transparency = 0;
  if (phylactere.transparency > 100) phylactere.transparency = 100;
  if (phylactere.transparency_red < 0) phylactere.transparency_red = 0;
  if (phylactere.transparency_red > 255) phylactere.transparency_red = 255;
  if (phylactere.transparency_green < 0) phylactere.transparency_green = 0;
  if (phylactere.transparency_green > 255) phylactere.transparency_green = 255;
  if (phylactere.transparency_blue < 0) phylactere.transparency_blue = 0;
  if (phylactere.transparency_blue > 255) phylactere.transparency_blue = 255;
  if ((phylactere.skip_mode != eSkipTimer) && (phylactere.skip_mode != eSkipKeyOrClick) && (phylactere.skip_mode != eSkipOnlyKeyOrClick)) phylactere.skip_mode = eSkipKeyOrClick;

  // Arrt du personnage si en mouvement
  if (phylactere.is_transparent) {
    if (this.Moving) this.StopMoving();
  }
  int char_x = this.x;
  int char_y = this.y;
  int view_x = GetViewportX();
  int view_y = GetViewportY();

  // Cration de la surface
  DynamicSprite *screen = DynamicSprite.CreateFromBackground();
  DrawingSurface *surface = screen.GetDrawingSurface();
  surface.Clear();
  int screen_width = surface.Width;
  int screen_height = surface.Height;

  // Lance l'animation "Speech"
  if (this.SpeechView > 0) {
    if (mode != ePhylactereThinking) {
      this.LockView(this.SpeechView);
      this.Animate(this.Loop, phylactere.view_speed , eRepeat, eNoBlock);
    }
  }

  // Recupration de la hauteur du personnage
  ViewFrame *char_frame = Game.GetViewFrame(this.View , this.Loop, this.Frame);
  int char_height = FloatToInt(IntToFloat(Game.SpriteHeight[char_frame.Graphic]) * IntToFloat(this.Scaling) / 100.0);
  
  // Dcoupage de la phrase
  String line[101];
  int line_width[101];
  int line_height[101];
  int nb_lines = 0;
  String tmp_line = str.Substring(0, 1);
  String tmp_line2 = "";
  int ind_str = 1;
  int width_max = 0;
  int height_max = 0;
  while ((ind_str < str.Length) && (nb_lines < 99)) {
    tmp_line2 = tmp_line.AppendChar(str.Chars[ind_str]);
    if (GetTextWidth(tmp_line2, Game.SpeechFont) > phylactere.width) {
      int seek_blank = tmp_line.Length - 1;
      while (seek_blank > 0 && tmp_line.Chars[seek_blank] != ' ') {
        seek_blank--;
      }
      if (seek_blank > 0) {
        tmp_line2 = tmp_line.Substring(seek_blank + 1 , tmp_line.Length - seek_blank);
        tmp_line2 = tmp_line2.AppendChar(str.Chars[ind_str]);
        tmp_line = tmp_line.Substring(0, seek_blank);
      } else {
        tmp_line2 = "";
        tmp_line2 = tmp_line2.AppendChar(str.Chars[ind_str]);
      }
      nb_lines++;
      line[nb_lines] = tmp_line;
      line_width[nb_lines] = GetTextWidth(line[nb_lines], Game.SpeechFont);
      line_height[nb_lines] = GetTextHeight(line[nb_lines], Game.SpeechFont, screen_width);
      if (line_width[nb_lines] > width_max) width_max = line_width[nb_lines];
      height_max = height_max + line_height[nb_lines];
    }
    tmp_line = tmp_line2;
    tmp_line2 = "";
    ind_str++;
  }
  nb_lines++;
  line[nb_lines] = tmp_line;
  line_width[nb_lines] = GetTextWidth(line[nb_lines], Game.SpeechFont);
  line_height[nb_lines] = GetTextHeight(line[nb_lines], Game.SpeechFont, screen_width);
  if (line_width[nb_lines] > width_max) width_max = line_width[nb_lines];
  height_max = height_max + line_height[nb_lines];

  // Calcul positions du texte
  int texte_x = char_x - (width_max / 2) - GetViewportX();
  int texte_y = char_y - char_height - height_max - GetViewportY() - queue_height - phylactere.distance_from_head;
  if (texte_x < 0) texte_x = 0;
  if (texte_y < 0) texte_y = 0;
  if (texte_x + width_max + GetViewportX() > screen_width) texte_x = screen_width - width_max - GetViewportX();
  
  // Calcul positions de la bulle
  int bulle_x1 = texte_x - 5;
  int bulle_y1 = texte_y - 1 + phylactere.ajust_htext;
  int bulle_x2 = texte_x + width_max + 5;
  int bulle_y2 = texte_y + height_max + phylactere.ajust_htext;
  
  // ---- Bulle ----
  DrawingSurface* background_surface;
  DynamicSprite* background_sprite;
  if (phylactere.is_transparent) {
    bool mouse_visible_before = Mouse.Visible;
    if (mouse_visible_before) Mouse.Visible = false;
    Wait(1);
    background_sprite = DynamicSprite.CreateFromScreenShot();
    if (mouse_visible_before) Mouse.Visible = true;
    background_surface = background_sprite.GetDrawingSurface();
    int by = bulle_y1;
    int bx;
    while (by <= bulle_y2) {
      bx = bulle_x1;
      while (bx <= bulle_x2) {
        int col = background_surface.GetPixel(bx, by);
        getRVG(col);
        surface.DrawingColor = Game.GetColorFromRGB(Phylactere_col_r, Phylactere_col_g, Phylactere_col_b);
        surface.DrawPixel(bx, by);
        bx++;
      }
      by++;
    }
    
    bx = bulle_x1 - 1;
    by = bulle_y1 + 1;
    while (by <= bulle_y2 - 1) {
      int col = background_surface.GetPixel(bx, by);
      getRVG(col);
      surface.DrawingColor = Game.GetColorFromRGB(Phylactere_col_r, Phylactere_col_g, Phylactere_col_b);
      surface.DrawPixel(bx, by);
      by++;
    }

    bx = bulle_x2 + 1;
    by = bulle_y1 + 1;
    while (by <= bulle_y2 - 1) {
      int col = background_surface.GetPixel(bx, by);
      getRVG(col);
      surface.DrawingColor = Game.GetColorFromRGB(Phylactere_col_r, Phylactere_col_g, Phylactere_col_b);
      surface.DrawPixel(bx, by);
      by++;
    }

    bx = bulle_x1 + 1;
    by = bulle_y1 - 1;
    while (bx <= bulle_x2 - 1) {
      int col = background_surface.GetPixel(bx, by);
      getRVG(col);
      surface.DrawingColor = Game.GetColorFromRGB(Phylactere_col_r, Phylactere_col_g, Phylactere_col_b);
      surface.DrawPixel(bx, by);
      bx++;
    }

    bx = bulle_x1 + 1;
    by = bulle_y2 + 1;
    while (bx <= bulle_x2 - 1) {
      int col = background_surface.GetPixel(bx, by);
      getRVG(col);
      surface.DrawingColor = Game.GetColorFromRGB(Phylactere_col_r, Phylactere_col_g, Phylactere_col_b);
      surface.DrawPixel(bx, by);
      bx++;
    }

    bx = bulle_x1 - 2;
    by = bulle_y1 + 3;
    while (by <= bulle_y2 - 3) {
      int col = background_surface.GetPixel(bx, by);
      getRVG(col);
      surface.DrawingColor = Game.GetColorFromRGB(Phylactere_col_r, Phylactere_col_g, Phylactere_col_b);
      surface.DrawPixel(bx, by);
      by++;
    }

    bx = bulle_x2 + 2;
    by = bulle_y1 + 3;
    while (by <= bulle_y2 - 3) {
      int col = background_surface.GetPixel(bx, by);
      getRVG(col);
      surface.DrawingColor = Game.GetColorFromRGB(Phylactere_col_r, Phylactere_col_g, Phylactere_col_b);
      surface.DrawPixel(bx, by);
      by++;
    }

    bx = bulle_x1 + 3;
    by = bulle_y1 - 2;
    while (bx <= bulle_x2 - 3) {
      int col = background_surface.GetPixel(bx, by);
      getRVG(col);
      surface.DrawingColor = Game.GetColorFromRGB(Phylactere_col_r, Phylactere_col_g, Phylactere_col_b);
      surface.DrawPixel(bx, by);
      bx++;
    }

    bx = bulle_x1 + 3;
    by = bulle_y2 + 2;
    while (bx <= bulle_x2 - 3) {
      int col = background_surface.GetPixel(bx, by);
      getRVG(col);
      surface.DrawingColor = Game.GetColorFromRGB(Phylactere_col_r, Phylactere_col_g, Phylactere_col_b);
      surface.DrawPixel(bx, by);
      bx++;
    }

  } else {
    surface.DrawingColor = phylactere.background_color;
    surface.DrawRectangle(bulle_x1 , bulle_y1 ,  bulle_x2 ,  bulle_y2);
    surface.DrawLine(bulle_x1 - 1, bulle_y1 + 1 ,  bulle_x1 - 1 ,  bulle_y2 - 1);
    surface.DrawLine(bulle_x2 + 1, bulle_y1 + 1 ,  bulle_x2 + 1 ,  bulle_y2 - 1);
    surface.DrawLine(bulle_x1 + 1 ,  bulle_y1 - 1 ,  bulle_x2 - 1 ,  bulle_y1 - 1);
    surface.DrawLine(bulle_x1 + 1 ,  bulle_y2 + 1 ,  bulle_x2 - 1 ,  bulle_y2 + 1);
    surface.DrawLine(bulle_x1 - 2, bulle_y1 + 3 ,  bulle_x1 - 2 ,  bulle_y2 - 3);
    surface.DrawLine(bulle_x2 + 2, bulle_y1 + 3 ,  bulle_x2 + 2 ,  bulle_y2 - 3);
    surface.DrawLine(bulle_x1 + 3 ,  bulle_y1 - 2 ,  bulle_x2 - 3 ,  bulle_y1 - 2);
    surface.DrawLine(bulle_x1 + 3 ,  bulle_y2 + 2 ,  bulle_x2 - 3 ,  bulle_y2 + 2);
  }

  // ---- Contours ----
  surface.DrawingColor = phylactere.outline_color;
  surface.DrawLine(bulle_x1 - 3, bulle_y1 + 3 ,  bulle_x1 - 3 ,  bulle_y2 - 3);
  surface.DrawLine(bulle_x2 + 3, bulle_y1 + 3 ,  bulle_x2 + 3 ,  bulle_y2 - 3);
  surface.DrawLine(bulle_x1 + 3 ,  bulle_y1 - 3 ,  bulle_x2 - 3 ,  bulle_y1 - 3);
  surface.DrawLine(bulle_x1 + 3 ,  bulle_y2 + 3 ,  bulle_x2 - 3 ,  bulle_y2 + 3);
  
  //---- Angle suprieur gauche ----
  surface.DrawPixel(bulle_x1 - 2 , bulle_y1 + 2);
  surface.DrawPixel(bulle_x1 - 2 , bulle_y1 + 1);
  surface.DrawPixel(bulle_x1 - 1 , bulle_y1);
  surface.DrawPixel(bulle_x1 , bulle_y1 - 1);
  surface.DrawPixel(bulle_x1 + 1 , bulle_y1 - 2);
  surface.DrawPixel(bulle_x1 + 2 , bulle_y1 - 2);

  //---- Angle suprieur droit ----
  surface.DrawPixel(bulle_x2 + 2 , bulle_y1 + 2);
  surface.DrawPixel(bulle_x2 + 2 , bulle_y1 + 1);
  surface.DrawPixel(bulle_x2 + 1 , bulle_y1);
  surface.DrawPixel(bulle_x2 , bulle_y1 - 1);
  surface.DrawPixel(bulle_x2 - 1 , bulle_y1 - 2);
  surface.DrawPixel(bulle_x2 - 2 , bulle_y1 - 2);

  //---- Angle infrieur gauche ----
  surface.DrawPixel(bulle_x1 - 2 , bulle_y2 - 2);
  surface.DrawPixel(bulle_x1 - 2 , bulle_y2 - 1);
  surface.DrawPixel(bulle_x1 - 1 , bulle_y2);
  surface.DrawPixel(bulle_x1 , bulle_y2 + 1);
  surface.DrawPixel(bulle_x1 + 1 , bulle_y2 + 2);
  surface.DrawPixel(bulle_x1 + 2 , bulle_y2 + 2);

  //---- Angle infrieur droit ----
  surface.DrawPixel(bulle_x2 + 2 , bulle_y2 - 2);
  surface.DrawPixel(bulle_x2 + 2 , bulle_y2 - 1);
  surface.DrawPixel(bulle_x2 + 1 , bulle_y2);
  surface.DrawPixel(bulle_x2 , bulle_y2 + 1);
  surface.DrawPixel(bulle_x2 - 1 , bulle_y2 + 2);
  surface.DrawPixel(bulle_x2 - 2 , bulle_y2 + 2);
  
  // ---- Queue ----
  int char_dir = this.Loop; // 0=bas , 1=gauche, 2=droite, 3=haut
  int qy = bulle_y2 + 3;
  int qx;
  if ((char_dir == 1) || (char_dir == 0)) {
    qx = char_x - 10 - GetViewportX();
  } else {
    qx = char_x + 10 - GQueue[1].Length - GetViewportX();
  }
  int j = 1;
  while (j <= queue_height) {
    int i = 0; 
    while (i < GQueue[j].Length) {
      bool visible = false;
      if (GQueue[j].Chars[i] == 'X') {
        surface.DrawingColor = phylactere.outline_color;
        visible = true;
      }
      if (GQueue[j].Chars[i] == 'O') {
        if (phylactere.is_transparent) {
          int col;
          if ((char_dir == 1) || (char_dir == 0)) {
            col = background_surface.GetPixel(qx + i ,  qy + j - 1);
          } else {
            col = background_surface.GetPixel(qx + GQueue[j].Length - i ,  qy + j - 1);
          }
          getRVG(col);
          surface.DrawingColor = Game.GetColorFromRGB(Phylactere_col_r, Phylactere_col_g, Phylactere_col_b);
        } else {
          surface.DrawingColor = phylactere.background_color;
        }
        visible = true;
      }
      if (visible) {
        if ((char_dir == 1) || (char_dir == 0)) {
          surface.DrawPixel(qx + i ,  qy + j - 1);
        } else {
          surface.DrawPixel(qx + GQueue[j].Length - i ,  qy + j - 1);
        }
      }
      i++; 
    }
    j++;
  }
  if (phylactere.is_transparent) {
    background_surface.Release();
    background_sprite.Delete();
  }

  // Texte
  surface.DrawingColor = this.SpeechColor;
  int ii = 0;
  int jj = 0;
  while (ii < nb_lines) {
    ii++;
    surface.DrawString(texte_x + (width_max - line_width[ii]) / 2 , texte_y + jj , Game.SpeechFont ,  line[ii]); 
    jj = jj + line_height[ii]; 
  }

  // Affichage de la bulle
  int pos_x = bulle_x1 - 4;
  if (pos_x < 0) pos_x = 0;
  int pos_y = bulle_y1 - 4;
  if (pos_y < 0) pos_y = 0;
  int lng_x = bulle_x2 + 4;
  int lng_y = bulle_y2 + 4 + queue_height;
  
  if (lng_x >= screen_width) lng_x = screen_width - 1;
  if (lng_y >= screen_height) lng_y = screen_height - 1;

  ds[this.ID] = DynamicSprite.CreateFromDrawingSurface(surface, pos_x, pos_y, lng_x - pos_x + 1 ,  lng_y - pos_y + 1);
  surface.Release();
  screen.Delete();
  bulle[this.ID] = Overlay.CreateGraphical(pos_x, pos_y, ds[this.ID].Graphic, true);

  mod[this.ID] = mode;
  
  charx[this.ID] = char_x;
  chary[this.ID] = char_y;
  posx[this.ID] = pos_x;
  posy[this.ID] = pos_y;
  viewx[this.ID] = view_x;
  viewy[this.ID] = view_y;
  
}


function Phylactere(this Character* , String str,  PhylactereQueueMode mode) {
  
  isbackground[this.ID] = false;
  this.prepare(str, mode);

  // Attente
  tempo[this.ID] = FloatToInt(IntToFloat(str.Length) * IntToFloat(phylactere.speed) / 10.0);
  if (tempo[this.ID] < 40) tempo[this.ID] = 40;
  bool stop = false;
  while (!stop){
    
    if (!phylactere.is_transparent) {
      bulle[this.ID].Remove();
      int nx = posx[this.ID] + (this.x - charx[this.ID]) - (GetViewportX() - viewx[this.ID]);
      int ny = posy[this.ID] + (this.y - chary[this.ID]) - (GetViewportY() - viewy[this.ID]);
      bulle[this.ID] = Overlay.CreateGraphical(nx, ny, ds[this.ID].Graphic, true);
    }
    
    if (phylactere.skip_mode != eSkipOnlyKeyOrClick) tempo[this.ID]--;
    if (phylactere.skip_mode >= eSkipKeyOrClick) {
      int wm = WaitMouseKey(1);
      if (wm == 1) stop = true;
    }
    if (phylactere.skip_mode == eSkipTimer) {
      Wait(1);
    }
    if (tempo[this.ID] == 0) stop = true;
  }
  
  Efface_Bulle(this.ID);
  
}


function PhylactereBackground(this Character* , String str,  PhylactereQueueMode mode) {
  
  isbackground[this.ID] = true;
  this.prepare(str, mode);
  
  // Attente
  tempo[this.ID] = FloatToInt(IntToFloat(str.Length) * IntToFloat(phylactere.speed) / 10.0);
  if (tempo[this.ID] < 40) tempo[this.ID] = 40;
   
}


// Gestion de l'affichage des bulles d'arrire-plan
function repeatedly_execute_always() {
  
  int i = 0;
  while (i < Game.CharacterCount) {
  
    if ((bulle[i] != null) && (bulle[i].Valid) && (isbackground[i])) {
    
      if (tempo[i]) {
        if (!phylactere.is_transparent) {
          bulle[i].Remove();
          int nx = posx[i] + (character[i].x - charx[i]) - (GetViewportX() - viewx[i]);
          int ny = posy[i] + (character[i].y - chary[i]) - (GetViewportY() - viewy[i]);
          bulle[i] = Overlay.CreateGraphical(nx, ny, ds[i].Graphic, true);
        }
        tempo[i]--;
      }
      // A la fin, on efface la bulle (suppression des pointeurs)
      else Efface_Bulle(i);
    
    }
    
    i++;
  
  }
  
}

// Cette fonction "nettoie" les pointeurs
function PhylactereFree() {
  
  int i = 0;
  while (i < Game.CharacterCount) {
    bulle[i] = null;
    ds[i] = null;
    tempo[i] = 0;
    i++;
  }
  
}

// Lorsque le joueur change de pice, il faut supprimer toute rfrence aux sprites dynamiques
function on_event (EventType event, int data) {
  
  if (event == eEventLeaveRoom) PhylactereFree();
  
} E  //===================================================================
// *** AGS MODULE HEADER ***
//
// Module: Phylactere
//
// Author: Asraroth (http://adventuregamestudio.fr-bb.com)
//
// Copyright (C) 2009  Asraroth
//
// Modified by: Kitai (http://adventuregamestudio.fr-bb.com) UNOFFICIAL
//
//-------------------------------------------------------------------

//===================================================================
// Dependancies:
// The following constant definitions allow the compiler to check for
// module  dependencies and to issue appropiate error messages when a
// required module is not installed. There should be a definition for
// the current version and all previous compatiable versions. 
//-------------------------------------------------------------------
	// Define this module's version info
	#define Phylactere_VERSION 0233_MODIFIED

	// Check for correct AGS version
	#ifdef AGS_SUPPORTS_IFVER
	#ifnver 3
	#error Module Phylactere requires AGS V3 or above
	#endif
	#endif

//===================================================================
// Configuration:
// The following constant definitions are used to modify the behavior
// of this module.  
//-------------------------------------------------------------------

enum PhylactereQueueMode {
  ePhylactereThinking, 
  ePhylactereTalking
};

enum PhylactereSkipMode {
  eSkipTimer, 
  eSkipKeyOrClick, 
  eSkipOnlyKeyOrClick 
};

import function Phylactere(this Character* , String s, PhylactereQueueMode Mode = ePhylactereTalking);
import function PhylactereBackground(this Character* , String s, PhylactereQueueMode Mode = ePhylactereTalking);

import function PhylactereFree();

struct Phylactere_Param{
  int width;                     // largeur maximum en pixel
  int background_color;          // couleur de fond de la bulle (non transparente)
  int outline_color;             // couleur du contour de la bulle
  int speed;                     // vitesse d'affichage (par defaut = 35)
  int view_speed;                // vitesse de la view "speak" (par defaut = 0) 
  bool is_transparent;           // true ou false
  int transparency;              // pourcentage de transparence 0 E100%
  int transparency_red;          // composante rouge de la couleur de transparence 0-255
  int transparency_green;        // composante verte
  int transparency_blue;         // composante bleue
  int distance_from_head;        // distance entre la bulle et la tte du personnage
  int ajust_htext;               // ajuste la position verticale du texte dans la bulle
  PhylactereSkipMode skip_mode;  // Mode pour passer la lecture de la bulle (eSkipKeyOrClick, eSkipTimer ou eSkipOnlyKeyOrClick)
};

import Phylactere_Param phylactere;
 .A        ej